(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
	(factory((global.ReactAwesomeCarousel = {}),global.React));
}(this, (function (exports,React) { 'use strict';

React = React && React.hasOwnProperty('default') ? React['default'] : React;

function gen(number, position, width, likelyWidth, action) {
	var count = number;
	var generate = "" + count;
	generate = generate.split(".");
	if (generate[1]) {
		var string_number = generate[1][0] + "." + generate[1].slice(1, generate[1].length);
		if (string_number.split(".")[1].length == 0) {
			string_number = string_number.replace(".", "");
		}
		var generate_to_float_number = parseFloat(string_number);

		if (action == "PLUS") {
			var v1 = width / 10 * generate_to_float_number;
			var v2 = width - v1;
			return Math.abs(position) + v2;
		} else {
			var v1 = width / 10 * generate_to_float_number;
			return Math.abs(position) - v1;
		}
	}
}

function calcStepper(position, count, slickElementsCount, width) {
	var c = position / (count * width);
	c = Math.abs(c);
	c = Math.round(c);

	return c;
}

var asyncGenerator = function () {
  function AwaitValue(value) {
    this.value = value;
  }

  function AsyncGenerator(gen) {
    var front, back;

    function send(key, arg) {
      return new Promise(function (resolve, reject) {
        var request = {
          key: key,
          arg: arg,
          resolve: resolve,
          reject: reject,
          next: null
        };

        if (back) {
          back = back.next = request;
        } else {
          front = back = request;
          resume(key, arg);
        }
      });
    }

    function resume(key, arg) {
      try {
        var result = gen[key](arg);
        var value = result.value;

        if (value instanceof AwaitValue) {
          Promise.resolve(value.value).then(function (arg) {
            resume("next", arg);
          }, function (arg) {
            resume("throw", arg);
          });
        } else {
          settle(result.done ? "return" : "normal", result.value);
        }
      } catch (err) {
        settle("throw", err);
      }
    }

    function settle(type, value) {
      switch (type) {
        case "return":
          front.resolve({
            value: value,
            done: true
          });
          break;

        case "throw":
          front.reject(value);
          break;

        default:
          front.resolve({
            value: value,
            done: false
          });
          break;
      }

      front = front.next;

      if (front) {
        resume(front.key, front.arg);
      } else {
        back = null;
      }
    }

    this._invoke = send;

    if (typeof gen.return !== "function") {
      this.return = undefined;
    }
  }

  if (typeof Symbol === "function" && Symbol.asyncIterator) {
    AsyncGenerator.prototype[Symbol.asyncIterator] = function () {
      return this;
    };
  }

  AsyncGenerator.prototype.next = function (arg) {
    return this._invoke("next", arg);
  };

  AsyncGenerator.prototype.throw = function (arg) {
    return this._invoke("throw", arg);
  };

  AsyncGenerator.prototype.return = function (arg) {
    return this._invoke("return", arg);
  };

  return {
    wrap: function (fn) {
      return function () {
        return new AsyncGenerator(fn.apply(this, arguments));
      };
    },
    await: function (value) {
      return new AwaitValue(value);
    }
  };
}();





var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var Carousel = function (_React$Component) {
	inherits(Carousel, _React$Component);

	function Carousel(props) {
		classCallCheck(this, Carousel);

		var _this = possibleConstructorReturn(this, (Carousel.__proto__ || Object.getPrototypeOf(Carousel)).call(this, props));

		_this.index = 1;
		_this.position = 0;
		_this.mousedownClientX = 0;
		_this.mousedownClientY = 0;
		_this.step = 0;
		_this.statusGalleryMove = false;
		_this.scrollStatus = false;
		_this.debounce = true;

		_this.next = function () {
			return _this.setMargin();
		};

		_this.state = {
			marginLeft: 0,
			data: props.data
		};

		_this.galleryScrolling = _this.galleryScrolling.bind(_this);
		_this.galleryScrollingMouseUp = _this.galleryScrollingMouseUp.bind(_this);
		_this.scrollbarScrolling = _this.scrollbarScrolling.bind(_this);
		_this.scrollbarScrollingMouseUp = _this.scrollbarScrollingMouseUp.bind(_this);
		_this.next = _this.next.bind(_this);
		_this.prev = _this.prev.bind(_this);
		_this.setMargin = _this.setMargin.bind(_this);
		_this.goTo = _this.goTo.bind(_this);
		_this.scroll = _this.scroll.bind(_this);
		_this.move = _this.move.bind(_this);
		return _this;
	}

	createClass(Carousel, [{
		key: "scrollbarScrollingMouseUp",
		value: function scrollbarScrollingMouseUp() {
			var _this2 = this;

			var touch = this.props.touch;

			if (!isNaN(this.state.marginLeft)) {
				this.position = this.state.marginLeft;
			}

			if (this.scrollStatus) {
				if (this.props.autoCorrect) {
					var autoCalculate;

					var count = this.position / this.props.itemWidth;
					var x = count;
					var int_part = Math.trunc(x);
					var float_part = Number((x - int_part).toFixed(1));
					float_part = Math.abs(float_part);

					if (float_part > 0.5 || float_part == 0.5) {
						autoCalculate = -gen(count, this.position, this.props.itemWidth, this.props.likelyWidth, "PLUS");
					} else if (float_part < 0.5) {
						autoCalculate = -gen(count, this.position, this.props.itemWidth, this.props.likelyWidth, "MIN");
					}
					if (!isNaN(autoCalculate)) {
						this.position = autoCalculate;
						this.setState({ marginLeft: autoCalculate });
					} else {
						this.forceUpdate();
					}
				}
			}

			if (this.debounce && this.props.onReachForScrollEnd) {
				this.props.onReachEnd();
				setTimeout(function () {
					return _this2.next();
				}, this.props.nextAfterFetchStarts);
			}

			this.scrollStatus = true;
			this.debounce = false;

			if (this.props.enableScrollbar) this.getScrollbar.scrollLeft = Math.abs(this.position);
			this.getScrollbar.removeEventListener(touch ? "touchmove" : "scroll", this.scroll, false);
			this.getScrollbar.removeEventListener(touch ? "touchend" : "mouseup", this.scrollbarScrollingMouseUp, false);
		}
	}, {
		key: "scrollbarScrolling",
		value: function scrollbarScrolling() {
			var touch = this.props.touch;

			this.debounce = true;
			this.scrollStatus = true;
			this.getScrollbar.addEventListener(touch ? "touchmove" : "scroll", this.scroll, false);
			this.getScrollbar.addEventListener(touch ? "touchend" : "mouseup", this.scrollbarScrollingMouseUp, false);
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			if (this.props.data.length !== prevProps.data.length) {
				this.setState({ data: this.props.data });
				this.forceUpdate();
			}
		}
	}, {
		key: "componentWillUpdate",
		value: function componentWillUpdate(nextProps, nextState) {
			this.step = calcStepper(this.position, this.props.showCount, this.state.data.length, this.props.itemWidth);
		}
	}, {
		key: "move",
		value: function move(e) {
			var _this3 = this;

			var _props = this.props,
			    touch = _props.touch,
			    vertical = _props.vertical;


			if (vertical) {
				var calc = touch ? this.mousedownClientY - e.touches[0].clientY : this.mousedownClientY - e.clientY;
			} else {
				var calc = touch ? this.mousedownClientX - e.touches[0].clientX : this.mousedownClientX - e.clientX;
			}
			var result = this.position + -calc;

			var pureResult = Math.abs(result);
			if (pureResult >= (this.state.data.length - this.props.showCount) * this.props.itemWidth) {
				result = -(this.state.data.length - this.props.showCount) * this.props.itemWidth;
				if (this.state.marginLeft == 0) result = 0;
				if (this.debounce && this.props.onReachForMove) {
					this.props.onReachEnd();
					setTimeout(function () {
						return _this3.next();
					}, this.props.nextAfterFetchStarts);
					this.debounce = false;
				}
			} else if (result > 0) {
				result = 0;
			}

			this.setState({ marginLeft: result });
			this.statusGalleryMove = true;
		}
	}, {
		key: "scroll",
		value: function scroll(e) {
			var _this4 = this;

			var scrollLeft = e.target.scrollLeft;
			var result = scrollLeft;

			this.position = -result;

			var carouselWidth = (this.state.data.length - this.props.showCount) * this.props.itemWidth;
			if (scrollLeft >= carouselWidth) {
				result = carouselWidth;
				if (this.debounce && this.props.onReachForScroll) {
					this.props.onReachEnd();
					setTimeout(function () {
						return _this4.next();
					}, this.props.nextAfterFetchStarts);
					this.debounce = false;

					this.scrollbarScrollingMouseUp();
				}
			}
			this.setState({ marginLeft: -result });
		}
	}, {
		key: "galleryScrollingMouseUp",
		value: function galleryScrollingMouseUp() {
			var _this5 = this;

			var touch = this.props.touch;

			if (!isNaN(this.state.marginLeft)) {
				this.position = this.state.marginLeft;
			}

			if (this.statusGalleryMove) {
				if (this.props.autoCorrect) {
					var autoCalculate;

					var count = this.position / this.props.itemWidth;
					var x = count;
					var int_part = Math.trunc(x);
					var float_part = Number((x - int_part).toFixed(1));
					float_part = Math.abs(float_part);

					float_part = float_part == 0 ? 0.1 : float_part;

					if (float_part > 0.5 || float_part == 0.5) {
						autoCalculate = -gen(count, this.position, this.props.itemWidth, this.props.likelyWidth, "PLUS");
					} else if (float_part < 0.5) {
						autoCalculate = -gen(count, this.position, this.props.itemWidth, this.props.likelyWidth, "MIN");
					}

					if (!isNaN(autoCalculate)) {
						this.position = autoCalculate;
						this.setState({ marginLeft: autoCalculate });
					} else {
						this.forceUpdate();
					}
				}

				if (this.debounce && Math.abs(this.position) >= (this.state.data.length - this.props.showCount) * this.props.itemWidth && this.props.onReachForMouseUp) {
					this.props.onReachEnd();
					setTimeout(function () {
						return _this5.next();
					}, this.props.nextAfterFetchStarts);
				}
			}

			this.debounce = false;

			this.statusGalleryMove = false;

			this.mousedownClientX = 0;

			if (this.props.enableScrollbar) this.getScrollbar.scrollLeft = Math.abs(this.position);

			this.getGallery.removeEventListener(touch ? "touchmove" : "mousemove", this.move, false);
			this.getGallery.addEventListener(touch ? "touchend" : "mouseup", this.galleryScrollingMouseUp, false);
		}
	}, {
		key: "galleryScrolling",
		value: function galleryScrolling(e) {
			var _props2 = this.props,
			    touch = _props2.touch,
			    vertical = _props2.vertical;

			this.debounce = true;

			if (vertical) {
				this.mousedownClientY = touch ? e.touches[0].clientY : e.clientY;
			} else {
				this.mousedownClientX = touch ? e.touches[0].clientX : e.clientX;
			}
			this.statusGalleryMove = false;
			this.getGallery.addEventListener(touch ? "touchmove" : "mousemove", this.move, false);
			this.getGallery.addEventListener(touch ? "touchend" : "mouseup", this.galleryScrollingMouseUp, false);
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			var touch = this.props.touch;

			if (this.props.enableScrollbar) {
				this.getScrollbar = this.refs.c.querySelector(".--rac-component-scrollbar");
				this.getScrollbar.addEventListener(touch ? "touchstart" : "mousedown", this.scrollbarScrolling, false);
			}
			if (this.props.enableMoving) {
				this.getGallery = this.refs.c.querySelector(".--rac-component-ul");

				this.getGallery.addEventListener(touch ? "touchstart" : "mousedown", this.galleryScrolling, false);
			}
		}
	}, {
		key: "setMargin",
		value: function setMargin() {
			var step = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props.showCount;

			var width = this.props.itemWidth;
			var count = step;

			var g = this.state.data.length;

			if (Math.max(this.position - width * count, -width * (g - count)) == this.position && this.props.infinite == true) {
				this.position = 0;
				this.setState({ marginLeft: 0 });
			} else {
				this.position = Math.max(this.position - width * count, -width * (g - count));

				this.setState({ marginLeft: this.position });
			}

			if (this.props.enableScrollbar) this.getScrollbar.scrollLeft = Math.abs(this.position);
		}
	}, {
		key: "prev",
		value: function prev() {
			var width = this.props.itemWidth;
			var count = this.props.showCount;

			if (this.position == 0 && this.props.infinite == true) {
				this.position = -(this.state.data.length - this.props.showCount) * this.props.itemWidth;
			} else {
				this.position = Math.min(this.position + width * count, 0);
			}
			this.setState({ marginLeft: this.position });

			if (this.props.enableScrollbar) this.getScrollbar.scrollLeft = Math.abs(this.position);
		}
	}, {
		key: "goTo",
		value: function goTo(c) {
			var _this6 = this;

			var pure_position = Math.abs(this.position);
			if (c == Math.floor(this.props.data.length / this.props.showCount) && this.props.onReachForDots) {
				this.props.onReachEnd();
				setTimeout(function () {
					return _this6.next();
				}, this.props.nextAfterFetchStarts);
			}
			if (c > this.index || c == this.index) {
				if (c == Math.floor(this.state.data.length / this.props.showCount)) {
					var result = pure_position + (this.state.data.length - pure_position / this.props.itemWidth - this.props.showCount) * this.props.itemWidth;
				} else {
					var v1 = this.props.showCount * this.props.itemWidth;
					var result = c * v1;
				}
			} else {
				if (c == 0) {
					var result = pure_position - pure_position / this.props.itemWidth * this.props.itemWidth;
				} else {
					var result = pure_position - (this.index - c) * (this.props.showCount * this.props.itemWidth);
				}
			}

			if (this.props.enableScrollbar) this.getScrollbar.scrollLeft = result;

			this.position = -result;

			this.setState({ marginLeft: -result });

			this.index = c;
		}
	}, {
		key: "render",
		value: function render() {
			var step = this.step,
			    goTo = this.goTo,
			    next = this.next,
			    prev = this.prev;
			var data = this.state.data;
			var _props3 = this.props,
			    itemWidth = _props3.itemWidth,
			    showCount = _props3.showCount;

			var calc_scrollbar = data.length * itemWidth;
			var calc_carousel_width = itemWidth * showCount;

			var Scrollbar = React.createElement(
				"div",
				{ className: "--rac-component-scrollbar" },
				React.createElement("div", { className: "--rac-component-inner", style: { width: calc_scrollbar + "px" } })
			);

			return React.createElement(
				"div",
				{ ref: "c", className: "--rac-component-carousel", style: _extends({ width: calc_carousel_width + "px" }, this.props.style) },
				this.props.children({
					style: { width: calc_carousel_width + "px" },
					className: "--rac-component-gallery"
				}, {
					style: { marginLeft: this.state.marginLeft + "px" },
					className: "--rac-component-ul"
				}, data, step, goTo, next, prev, Scrollbar, { showCount: showCount, data: data, current: step })
			);
		}
	}]);
	return Carousel;
}(React.Component);

Carousel.defaultProps = {
	enableScrollbar: false,
	enableMoving: false,
	autoCorrect: false,
	onReachForMouseUp: false,
	onReachForMove: false,
	onReachForScroll: false,
	onReachForScrollEnd: false,
	onReachForDots: false,
	onReachEnd: undefined,
	touch: false,
	infinite: false,
	nextAfterFetchStarts: 0,
	vertical: false,
	style: {}
};

var Dots = function (_React$Component) {
	inherits(Dots, _React$Component);

	function Dots(props) {
		classCallCheck(this, Dots);

		var _this = possibleConstructorReturn(this, (Dots.__proto__ || Object.getPrototypeOf(Dots)).call(this, props));

		_this.goTo = function (indx) {
			return _this.props.goTo(indx);
		};

		_this.state = {
			s: _this.calcInitialState(false)
		};

		_this.goTo = _this.goTo.bind(_this);
		_this.calcInitialState = _this.calcInitialState.bind(_this);
		window.dots = _this;
		return _this;
	}

	createClass(Dots, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(_ref) {
			var current = _ref.current;

			if (current !== this.props.current) {
				var s = this.state.s;
				for (var i = 0; i < s.length; i++) {
					if (i == current) {
						s[i].active = true;
					} else {
						s[i].active = false;
					}
				}

				this.setState({ s: s });
			}
		}
	}, {
		key: "componentWillMount",
		value: function componentWillMount() {
			var s = this.state.s;
			for (var i = 0; i < s.length; i++) {
				if (i == this.props.current) {
					s[i].active = true;
				} else {
					s[i].active = false;
				}
			}
			this.setState({ s: s });
		}
	}, {
		key: "calcInitialState",
		value: function calcInitialState() {
			var setActive = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

			var ii = void 0;
			if (setActive) {
				ii = this.state.s[this.props.current].i;
			}
			var c = [];
			for (var i = 0; i < this.props.data.length / this.props.showCount; i++) {
				if (typeof ii == "number" && ii === i) {
					c.push({ i: i, active: true });
				} else {
					c.push({ i: i, active: false });
				}
			}

			return c;
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(_ref2, prevState) {
			var data = _ref2.data;

			if (this.props.data.length !== data.length) {
				this.setState({ s: this.calcInitialState(true) });
			}
		}
	}, {
		key: "render",
		value: function render() {
			var c = [];
			for (var i = 0; i < this.state.s.length; i++) {
				c.push(this.props.renderDots(i, this.goTo, this.state.s[i].active, this.activePosition));
			}

			return React.createElement(
				"ul",
				_extends({ className: "--rac-component-dots" }, this.props),
				c
			);
		}
	}]);
	return Dots;
}(React.Component);

exports.Carousel = Carousel;
exports.Dots = Dots;

Object.defineProperty(exports, '__esModule', { value: true });

})));
